#include "StdAfx.h"
#include "WASListMember.h"
#include "ConvertUTF.h"
#include "MessengerActor.h"
#include "UtilFunction.h"
#include "GameTalkAPIGlobal.h"


CWASListMember::CWASListMember(CWASActor *pActor) : 
	CWASCommand(pActor), m_nGroupType(0)
{
}


CWASListMember::~CWASListMember(void)
{
}


void CWASListMember::ExecuteAsync()
{
	m_listMemberPrivate.clear();
	m_listMember.clear();

	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if (pMessengerActor == NULL)
	{
		return;
	}	

	USES_CONVERSION;
	USES_UTF8_CONVERSION;

	WSTRING strURL = _T("");

	if (this->m_nGroupType == 1)
	{
		strURL = m_pActor->GetWASServerAddress();
		strURL += _T("/ne/org/ListOrgMember.php"); // 
	}
	else
	{
		strURL = m_pActor->GetWASServerAddress();
		strURL += _T("/ne/org/ListWorkMember.php");		// ׷
	}

	m_httpFacade.session().SetURL( T2CA(strURL.c_str()), pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().SetMethod(HTTP_METHOD_POST);

	m_httpFacade.session().AddBodyVariable("userid", W2U8(pMessengerActor->GetUserID()));
	m_httpFacade.session().AddBodyVariable("ticket", pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().AddBodyVariable("grpid", W2U8(m_strGrpID.c_str()));
	m_httpFacade.session().AddBodyVariable("langcode", W2U8(m_strLangCode.c_str()));
	m_httpFacade.session().AddBodyVariable("function_list", W2U8(m_strFunction.c_str()));

	// ׷  ׷ID  ͵ ִ(Uniq key  ƴ)
	// ׷ θID  ־ Ѵ.
	if (this->m_nGroupType == 2)
		m_httpFacade.session().AddBodyVariable("uprgrpid", W2U8(m_strParentGrpID.c_str()));

	m_httpFacade.session().SetKeepRawHeader(TRUE);
	m_httpFacade.SendRequest(this);
}


bool CWASListMember::ParseAndEventFire(nfc::CIkXMLDom * pDom)
{
	if(pDom == NULL)
		return false;

	nfc::IIkXMLNode* pNode = pDom->GetdocumentElement()->selectSingleNode("nodes");
	if (pNode == NULL)
	{
		m_strWasErrMsg += _T("member list  \"<nodes>\" ã  ϴ.");
		return false;
	}

	nfc::IIkXMLNodeList *pList = pNode->selectNodes("node");	
	nfc::IIkXMLAttribute* pAttr;
	USES_CONVERSION;
	USES_UTF8_CONVERSION;

	m_listMemberPrivate.clear();

	for (int i = 0; i < pList->Getlength(); i++)
	{	
		NE_MEMBER_DATA sAddrPrivate;// Ź  ʱȭ
		pNode = pList->Getitem(i);
		GT_ASSERT(pNode);

		if (NULL == (pAttr = pNode->getAttribute("user_id")))// ʼ
			continue;	// ignore this item
		if (NULL != (pAttr = pNode->getAttribute("user_id")))// ʼ
			sAddrPrivate.strUserId = U82W(pAttr->Gettext().c_str());
		if (NULL != (pAttr = pNode->getAttribute("emp_nm")))
			sAddrPrivate.strName = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("grpid")))
			sAddrPrivate.strDeptId= U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("dept_nm")))
			sAddrPrivate.strDept = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("jbps_nm")))
			sAddrPrivate.strJobPos = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("jbps_cd")))
			sAddrPrivate.strJobPosCd = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("jbdt_nm")))
			sAddrPrivate.strJobDuty = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("jbdt_cd")))
			sAddrPrivate.strJobDutyCd = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("tel_no")))		// ȸ ȣ
			sAddrPrivate.strIncoTel = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("inco_tel_no")))	//  ȣ
			sAddrPrivate.strExtesion = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("fax_no")))
			sAddrPrivate.strFaxNum = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("cph_no")))
			sAddrPrivate.strCellPhone = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("ipph_no")))
			sAddrPrivate.strIPPhone = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("email_addr")))
			sAddrPrivate.strEmail = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("rmngph_no")))
			sAddrPrivate.strRmngPhone = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("kwd_nm")))
			sAddrPrivate.strKeyword = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("workpl_nm")))
			sAddrPrivate.strWorkPlace = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("work_status")))
			sAddrPrivate.strWorkStatus = U82W(pAttr->Gettext().c_str());


		m_listMemberPrivate.push_back(sAddrPrivate);
	}

	return true;
}


// override in drived class
void CWASListMember::OnWasResponse(trid_t trid,
								  bool bSuccess,
								  int /*nWinINetErrorCode*/, 
								  int /*nHttpResponseCode*/, 
                                  LPCSTR /*szWasResCodeInHeader*/, 
                                  LPCSTR szWasResCodeInXml,
                                  nfc::CIkXMLDom * pDom)
{
	if(bSuccess)
	{
		if(ParseAndEventFire(pDom) == false)
			m_eError = wasError_Protocol;
	}

	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();

	// wstring LPCWSTR ȯؼ 迭  ־!!!
	for(size_t i = 0; i < m_listMemberPrivate.size(); i++)
	{
		NE_MEMBER_DATA sTemp;
		//m_listMemberPrivate[i].Convert(sTemp);
		sTemp = m_listMemberPrivate[i];
		m_listMember.push_back(sTemp);
	}

    NE_MEMBER_DATA_LIST sList;
	sList.nSize = m_listMember.size();
	sList.pList = sList.nSize > 0 ? &m_listMember[0] : NULL;

	for (; it != observers.end(); ++it)
	{
		IGTWASActorEvent *pObserver = static_cast<IGTWASActorEvent *>(*it);
		if(pObserver->OnGTWASActor_ResponseMemberList(m_pActor, GetID(), m_eError, sList) == false)
			break;
		//pObserver->OnGTWASActor_ResponseMemberList(m_pActor, GetID(), m_eError, sList);
	}

	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}


void CWASListMember::OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/)
{
	m_eError = wasError_Timeout;

	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();

	// wstring LPCWSTR ȯؼ 迭  ־!!!
	for(size_t i = 0; i < m_listMemberPrivate.size(); i++)
	{
		NE_MEMBER_DATA sTemp;
		sTemp = m_listMemberPrivate[i];
		m_listMember.push_back(sTemp);
	}

	NE_MEMBER_DATA_LIST sList;
	sList.nSize = m_listMember.size();
	sList.pList = sList.nSize > 0 ? &m_listMember[0] : NULL;

	for (; it != observers.end(); ++it)
	{
		IGTWASActorEvent *pObserver = static_cast<IGTWASActorEvent *>(*it);
		if(pObserver->OnGTWASActor_ResponseMemberList(m_pActor, GetID(), m_eError, sList) == false)
			break;
	}

	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}
